package jp.gr.java_conf.matsubara.expresser;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.ResourceBundle;

import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.operatorset.*;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.ExpArrayInitializer;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.ExpObjectInitializer;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.Op_ArrayAccessExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.Op_FunctionCallExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.Op_IncrementExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.Op_LogicalAndExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.Op_LogicalOrExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.Op_MemberAccessExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.Op_SubstituteExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.ParsedExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.WrappedExpression;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.WrappedVariableExpression;
import jp.gr.java_conf.matsubara.expresser.type.*;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpArray_constructor;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpBoolean_constructor;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpDate_constructor;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpError_constructor;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpNumber_constructor;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpObject_constructor;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpRegExp_constructor;
import jp.gr.java_conf.matsubara.expresser.type.constructor.ExpString_constructor;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__decodeURI;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__encodeURI;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__escape;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__isFinite;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__isNaN;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__loadClass;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__parseFloat;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__parseInt;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__unescape;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__write;
import jp.gr.java_conf.matsubara.expresser.type.property.Global__writeln;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__abs;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__acos;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__asin;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__atan;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__atan2;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__ceil;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__cos;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__exp;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__floor;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__log;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__max;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__min;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__pow;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__random;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__round;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__sin;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__sqrt;
import jp.gr.java_conf.matsubara.expresser.type.property._Math__tan;
import jp.gr.java_conf.matsubara.resource.DynaResourceBundle;

/**
 * Z<br/>
 * vZvZʂ𓾂NXłB<br/>
 * <br/>
 * 쐬: 2004/12/23
 * 
 * @author m.matsubara
 * 
 */
public class Expresser {
    private static final int LAST_CHAR_NONE = 0;        //  O͂̕Ȃiŏ̕j
    private static final int LAST_CHAR_OPERATOR = 1;    //  O͉̕Zq
    private static final int LAST_CHAR_VALUE = 2;       //  O͉̕炩̒li֐Ăяo܂ށj
    private static final int LAST_CHAR_NUMBER = 3;      //  O͐̕
    private static final int LAST_CHAR_VARIABLE = 5;    //  O͕̕ϐ
    
    public static String RESOURCE_NAME = "jp.gr.java_conf.matsubara.expresser.ExpresserRes";
    public static DynaResourceBundle resource = null;

    /** OperatorSetőΉłȂZqłꍇԂliG[j */
    public static final IExpObject UNSUPPORTED_OPERATOR = new Undefined();
    
    /** EcmaScript undefined */
    public static final IExpObject UNDEFINED = new Undefined();
    
    /** Number^NaN\܂B */
    public static final double NaN = Double.NaN;
    
    /**
     *  ftHg̃^Cf[^(parseɎg܂)<br/>
     *  }`XbhłȂꍇÃ^Cf[^̂܂܎gĂǂA 
     *  }`XbhŎgpꍇÃftHg^Cf[^ƂĐV^Cf[^𐶐Kv܂B
     */
    private RuntimeData defaultRuntimeData;
    
    /** 
     * ZqZbg<br/>
     * OԖڂ̓ftHgZqZbgƂđΉ鉉ZqZbg̓肳Ȃ^̌ɗp܂B<br/>
     * PԖڂΉNXɓZqZbgo^Ă܂B<br/>
     * ^pNXp̓ZqZbgo^ꍇ́Ap̃NXpZqZbgՂɓo^܂B<br/>
     */
    private List operatorSetList = new ArrayList();
    /** ^ƉZqZbgт܂ */
    private HashMap operatorSetTable = new HashMap();
    
    /** Zq̏ */
    private List opeDataList = new ArrayList();
    
    /** ʉZq̎ʂɎgp */
    private OperatorData opeParenthesis = null;  
    
    /** \` */
    private HashMap reservedWords = new HashMap(); 
    
    /**
     * Expresser NX܂B<br/>
     * Zqo^AftHg^C쐬܂B
     * 
     * @exception ExpException
     */
    public Expresser() throws ExpException {
        //  ^Cf[^̍쐬
        defaultRuntimeData = new RuntimeData();
        defaultRuntimeData.setTypeConverter(new ExpTypeConverter());
        
        //  Zqo^
        int priority = 0;
        addOpeData(new OperatorData(".",   OperatorData.OP_MEMBER_ACCESS, priority, OperatorData.OP_CLS_BIN, false, false)); 
        opeParenthesis = new OperatorData("(", OperatorData.OP_PARENTHESIS,    priority, OperatorData.OP_CLS_PARENTHESIS, false, false);  
        addOpeData(new OperatorData("new", OperatorData.OP_CREATE_OBJECT, priority, OperatorData.OP_CLS_FRONT_UNITY, false, false)); 
        priority++;

        addOpeData(new OperatorData("++",  OperatorData.OP_ARI_INC_F, priority, OperatorData.OP_CLS_FRONT_UNITY, false, true)); 
        addOpeData(new OperatorData("--",  OperatorData.OP_ARI_DEC_F, priority, OperatorData.OP_CLS_FRONT_UNITY, false, true)); 
        addOpeData(new OperatorData("++",  OperatorData.OP_ARI_INC_B, priority, OperatorData.OP_CLS_BACK_UNITY, true, false)); 
        addOpeData(new OperatorData("--",  OperatorData.OP_ARI_DEC_B, priority, OperatorData.OP_CLS_BACK_UNITY, true, false)); 
        addOpeData(new OperatorData("!",   OperatorData.OP_LOG_NOT, priority, OperatorData.OP_CLS_FRONT_UNITY, false, false)); 
        addOpeData(new OperatorData("~",   OperatorData.OP_BIT_NOT, priority, OperatorData.OP_CLS_FRONT_UNITY, false, false));
        priority++;

        addOpeData(new OperatorData("+",   OperatorData.OP_PLUS,  priority, OperatorData.OP_CLS_FRONT_UNITY, false, false));
        addOpeData(new OperatorData("-",   OperatorData.OP_MINUS, priority, OperatorData.OP_CLS_FRONT_UNITY, false, false));
        priority++;

        addOpeData(new OperatorData("*",   OperatorData.OP_ARI_MUL, priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData("/",   OperatorData.OP_ARI_DIV, priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData("%",   OperatorData.OP_ARI_REM, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;

        addOpeData(new OperatorData("+",   OperatorData.OP_ARI_ADD, priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData("-",   OperatorData.OP_ARI_SUB, priority, OperatorData.OP_CLS_BIN, false, false));
        priority++;

        addOpeData(new OperatorData("<<",  OperatorData.OP_SFT_LEFT, priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData(">>",  OperatorData.OP_SFT_RIGHT, priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData(">>>",  OperatorData.OP_SFT_RIGHT_UNSIGNED, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
        
        addOpeData(new OperatorData(">=",  OperatorData.OP_CMP_GE,  priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData("<=",  OperatorData.OP_CMP_LE,  priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData(">",   OperatorData.OP_CMP_GT,  priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData("<",   OperatorData.OP_CMP_LT,  priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
        
        addOpeData(new OperatorData("instanceof",OperatorData.OP_INSTANCEOF,  priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;

        addOpeData(new OperatorData("==",  OperatorData.OP_CMP_EQ,  priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData("!=",  OperatorData.OP_CMP_NE,  priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData("===", OperatorData.OP_CMP_EQ_STRICT, priority, OperatorData.OP_CLS_BIN, false, false)); 
        addOpeData(new OperatorData("!==", OperatorData.OP_CMP_NE_STRICT, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;

        addOpeData(new OperatorData("&",   OperatorData.OP_BIT_AND, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
        
        addOpeData(new OperatorData("^",   OperatorData.OP_BIT_XOR, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
        
        addOpeData(new OperatorData("|",   OperatorData.OP_BIT_OR,  priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
        
        addOpeData(new OperatorData("&&",  OperatorData.OP_LOG_AND, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;

        addOpeData(new OperatorData("||",  OperatorData.OP_LOG_OR, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
        
        addOpeData(new OperatorData("?", OperatorData.OP_EXTERNAL_PARSED, priority, OperatorData.OP_CLS_BIN, false, false, new SelectOperatorParser()));

/*        
        addOpeData(new OperatorData(":",  OperatorData.OP_SEL_VALUES, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
        addOpeData(new OperatorData("?",  OperatorData.OP_SEL_SELECT, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
*/
        addOpeData(new OperatorData("+=",  OperatorData.OP_ARI_ADD_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("-=",  OperatorData.OP_ARI_SUB_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("*=",  OperatorData.OP_ARI_MUL_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("/=",  OperatorData.OP_ARI_DIV_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("%=",  OperatorData.OP_ARI_REM_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("&=",  OperatorData.OP_BIT_AND_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("|=",  OperatorData.OP_BIT_OR_SUBS,  priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("^=",  OperatorData.OP_BIT_XOR_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("<<=", OperatorData.OP_SFT_LEFT_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData(">>=", OperatorData.OP_SFT_RIGHT_SUBS,priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData(">>>=",OperatorData.OP_SFT_RIGHT_UNSIGNED_SUBS, priority, OperatorData.OP_CLS_BIN, true, false)); 
        addOpeData(new OperatorData("=",   OperatorData.OP_SUBSTITUTE, priority, OperatorData.OP_CLS_BIN, true, false)); 
        priority++;
        
        addOpeData(new OperatorData("delete", OperatorData.OP_DELETE_MEMBER, priority, OperatorData.OP_CLS_FRONT_UNITY, false, true)); 
        addOpeData(new OperatorData("typeof", OperatorData.OP_TYPEOF,        priority, OperatorData.OP_CLS_FRONT_UNITY, false, false)); 
        addOpeData(new OperatorData("void", OperatorData.OP_VOID,            priority, OperatorData.OP_CLS_FRONT_UNITY, false, false)); 
        priority++;
        
        addOpeData(new OperatorData(",",   OperatorData.OP_SEQUENSE, priority, OperatorData.OP_CLS_BIN, false, false)); 
        priority++;
        
        //  e^ɑΉZqZbgo^iォo^̂D悵Ďgpj
        operatorSetList.add(_DefaultOperatorSet.operatorSet);
        operatorSetList.add(VariableAndFunctionOperatorSet.operatorSet);
        operatorSetList.add(DateOperatorSet.operatorSet);
        operatorSetList.add(StringOperatorSet.operatorSet);
        operatorSetList.add(BooleanOperatorSet.operatorSet);
        operatorSetList.add(NumberOperatorSet.operatorSet);
        operatorSetList.add(DoubleOperatorSet.operatorSet);
        operatorSetList.add(LongOperatorSet.operatorSet);
        operatorSetList.add(IntegerOperatorSet.operatorSet);

        //  K̒萔ϐݒ
        //  v~eBu萔
        defaultRuntimeData.setConst(StringToId.toId("null"),     null);
        defaultRuntimeData.setConst(StringToId.toId("true"),     new _Boolean(true));
        defaultRuntimeData.setConst(StringToId.toId("false"),    new _Boolean(false));
        defaultRuntimeData.setValue(StringToId.toId("undefined"),Expresser.UNDEFINED);
        defaultRuntimeData.setValue(StringToId.toId("NaN"),      new _Double(Double.NaN));
        defaultRuntimeData.setValue(StringToId.toId("Infinity"), new _Double(Double.POSITIVE_INFINITY));
        
        //  O[o萔
        ExpObject mathClass = new ExpObject();
        mathClass.putConstProperty(_Math__abs.ID,               _Math__abs.getInstance());
        mathClass.putConstProperty(_Math__acos.ID,              _Math__acos.getInstance());
        mathClass.putConstProperty(_Math__asin.ID,              _Math__asin.getInstance());
        mathClass.putConstProperty(_Math__atan.ID,              _Math__atan.getInstance());
        mathClass.putConstProperty(_Math__atan2.ID,             _Math__atan2.getInstance());
        mathClass.putConstProperty(_Math__ceil.ID,              _Math__ceil.getInstance());
        mathClass.putConstProperty(_Math__cos.ID,               _Math__cos.getInstance());
        mathClass.putConstProperty(_Math__exp.ID,               _Math__exp.getInstance());
        mathClass.putConstProperty(_Math__floor.ID,             _Math__floor.getInstance());
        mathClass.putConstProperty(_Math__log.ID,               _Math__log.getInstance());
        mathClass.putConstProperty(_Math__max.ID,               _Math__max.getInstance());
        mathClass.putConstProperty(_Math__min.ID,               _Math__min.getInstance());
        mathClass.putConstProperty(_Math__pow.ID,               _Math__pow.getInstance());
        mathClass.putConstProperty(_Math__random.ID,            _Math__random.getInstance());
        mathClass.putConstProperty(_Math__round.ID,             _Math__round.getInstance());
        mathClass.putConstProperty(_Math__sin.ID,               _Math__sin.getInstance());
        mathClass.putConstProperty(_Math__sqrt.ID,              _Math__sqrt.getInstance());
        mathClass.putConstProperty(_Math__tan.ID,               _Math__tan.getInstance());
        mathClass.putConstProperty(StringToId.toId("E"),        new _Double(Math.E));
        mathClass.putConstProperty(StringToId.toId("PI"),       new _Double(Math.PI));
        mathClass.putConstProperty(StringToId.toId("LN10"),     new _Double(2.302585092994046));
        mathClass.putConstProperty(StringToId.toId("LN2"),      new _Double(0.6931471805599453));
        mathClass.putConstProperty(StringToId.toId("LOG10E"),   new _Double(0.43429448190325176));
        mathClass.putConstProperty(StringToId.toId("LOG2E"),    new _Double(1.4426950408889634));
        mathClass.putConstProperty(StringToId.toId("SQRT1_2"),  new _Double(Math.sqrt(0.5)));
        mathClass.putConstProperty(StringToId.toId("SQRT2"),    new _Double(Math.sqrt(2)));
        defaultRuntimeData.setValue(StringToId.toId("Math"),    mathClass);
        
        //  IuWFNg̃RXgN^
        //    RXgN^̏
        ExpArray.constructor = new ExpArray_constructor();
        ExpBoolean.constructor = new ExpBoolean_constructor();
        ExpDate.constructor = new ExpDate_constructor();
        ExpError.constructor = new ExpError_constructor();
        ExpNumber.constructor = new ExpNumber_constructor();
        ExpObject.constructor = new ExpObject_constructor();
        ExpRegExp.constructor = new ExpRegExp_constructor();
        ExpString.constructor = new ExpString_constructor();
        defaultRuntimeData.setValue(StringToId.toId("Array"),       ExpArray.constructor);
        defaultRuntimeData.setValue(StringToId.toId("Boolean"),     ExpBoolean.constructor);
        defaultRuntimeData.setValue(StringToId.toId("Date"),        ExpDate.constructor);
        defaultRuntimeData.setValue(StringToId.toId("Error"),       ExpError.constructor);
        defaultRuntimeData.setValue(StringToId.toId("Number"),      ExpNumber.constructor);
        defaultRuntimeData.setValue(StringToId.toId("Object"),      ExpObject.constructor);
        defaultRuntimeData.setValue(StringToId.toId("RegExp"),      ExpRegExp.constructor);
        defaultRuntimeData.setValue(StringToId.toId("String"),      ExpString.constructor);

        //  Global \bh
        defaultRuntimeData.setValue(Global__decodeURI.ID,           Global__decodeURI.getInstance());
        defaultRuntimeData.setValue(Global__encodeURI.ID,           Global__encodeURI.getInstance());
        defaultRuntimeData.setValue(Global__escape.ID,              Global__escape.getInstance());
        defaultRuntimeData.setValue(Global__isFinite.ID,            Global__isFinite.getInstance());
        defaultRuntimeData.setValue(Global__isNaN.ID,               Global__isNaN.getInstance());
        defaultRuntimeData.setValue(Global__parseFloat.ID,          Global__parseFloat.getInstance());
        defaultRuntimeData.setValue(Global__parseInt.ID,            Global__parseInt.getInstance());
        defaultRuntimeData.setValue(Global__unescape.ID,            Global__unescape.getInstance());
        //  W Global \bh
        defaultRuntimeData.setValue(StringToId.toId("print"),       Global__writeln.getInstance());
        defaultRuntimeData.setValue(Global__writeln.ID,             Global__writeln.getInstance());
        defaultRuntimeData.setValue(Global__write.ID,               Global__write.getInstance());
        defaultRuntimeData.setValue(Global__loadClass.ID,           Global__loadClass.getInstance());
    }
    
    /**
     * vZvZʂ𓾂܂B<br/>
     * vZʂ IVariable łꍇ܂B<br/>
     * ̏ꍇAŏIIȌvZʂ𓾂ꍇ IVariable#getValue() ĂяoKv܂B
     * <br/>
     * Zq̗D揇<br/>
     * 1 :  . [] () new <br/>
     * 2 : ++ -- ! ~ <br/>
     * 3 : + - (LXg邽߂̌^) (+ -͕ƂĂ̒PZq)<br/>
     * 4 : * / %<br/>
     * 5 : + - (ZEZ)<br/>
     * 6 : &lt;&lt; &gt;&gt; &gt;&gt;&gt;<br/>
     * 7 : &gt;= &gt; &lt;= &lt; <br/>
     * 8 : == != === !== <br/>
     * 9 : &<br/>
     * 10: ^<br/>
     * 11: |<br/>
     * 12: &&<br/>
     * 13: ||<br/>
     * 14: ?:<br/>
     * 15: = += -= *= /= %= &= ^= |= &lt;&lt;= &gt;&gt;= &gt;&gt;&gt;=<br/>
     * 16: delete typeof void<br/>
     * 17: ,
     * 
     * @param runtime ^Cf[^
     * @param sStatement vZ
     * @return vZʂłBAvZʂ IVariable łꍇ܂B
     * @throws ExpException vŽ
     */
    public IExpObject evaluate(RuntimeData runtime, String sStatement) throws ExpException {
        IParsedExpression parsedExpression = parse(sStatement.toCharArray(), 0, sStatement.length());
        return evaluate(runtime, parsedExpression);
    }
    
    /**
     * \͍ς݌vZvZ܂B
     * 
     * @param runtime ^Cf[^
     * @param parsedExpression ͍ς݌vZ
     * @return vZ
     * @throws ExpException sȌvZ
     */
    public static IExpObject evaluate(RuntimeData runtime, IParsedExpression parsedExpression) throws ExpException {
        //  Z
        IExpObject result = parsedExpression.evaluate(runtime);
        //  ŏIZʂXV
        runtime.lastResultValue = result;   //  TODO ܂߂ setter gƂ\@
        return result;
    }
    
    /**
     * vZ̍\͂s܂B
     * @param statement vZ 
     * @return \͂svZIuWFNg(IParsedExpression)
     * @throws ExpException
     */
    public IParsedExpression parse(String statement) throws ExpException {
        return parse(statement.toCharArray(), 0, statement.length());
    }

    /**
     * vZ̍\͂s܂B
     * @param statement vZ
     * @param range ͈
     * @return \͂svZIuWFNg(IParsedExpression)
     * @throws ExpException
     */
    public IParsedExpression parse(char [] statement, Range range) throws ExpException {
        return parse(statement, range.getBegin(), range.getEnd());
    }
    
    /**
     * vZ̍\͂s܂B
     * 
     * @param statement vZ
     * @param begin Jnʒu
     * @param end Iʒu
     * @return \͂svZIuWFNg(IParsedExpression)
     * @throws ExpException vŽ
     */
    public IParsedExpression parse(char [] statement, int begin, int end) throws ExpException {
//      System.out.println(String.valueOf(statement, begin, end - begin));
        
        int parenthesisDepth = 0;    //  ʂ̐[
        //  Ő󔒏()
        char beginChar = statement[begin];
        while (begin < end && (Character.isSpaceChar(beginChar) || beginChar == '\t' || beginChar == '\r' || beginChar == '\n')) {
            begin++;
            beginChar = statement[begin];
        }
        char endChar = beginChar;
        if (begin != end - 1) {
            endChar = statement[end - 1];
            while (begin < end && (Character.isSpaceChar(endChar) || beginChar == '\t' || beginChar == '\r' || beginChar == '\n')) {
                end--;
                endChar = statement[end - 1];
            }
        }
        if (begin >= end)
            throw new ExpException(getResString("EnptyExpression"), begin);

        //
        //  vZōŒ̗D揇ʂ̉Zq{
        //
        int idx = begin;
        OperatorData operator = null;
        int opeIdx = -1;    //  Zq̈ʒu
        int opePri = -1;    //  Zq̗Dx
        int lastCharType = Expresser.LAST_CHAR_NONE;
        while (idx < end) {
            char ch = statement[idx]; 
            if (ch == '(' || ch == '[' || ch == '{') {
                //  
                if (opePri <= opeParenthesis.getPriority()) {
                    operator = opeParenthesis;
                    opeIdx = idx;
                    opePri = opeParenthesis.getPriority();
                }
                idx = skipParenthesis(statement, idx, end);
                lastCharType = Expresser.LAST_CHAR_VALUE;   //  ʂĂ̂ŒlʂŊĂ邩A֐ĂяȍI
            }
            else if (ch == '\"' || ch == '\'') {
                idx = skipString(statement, idx, end);
                lastCharType = Expresser.LAST_CHAR_VALUE;    //  Ȃ̂Œl
            }
            else if ((lastCharType == Expresser.LAST_CHAR_NONE || lastCharType == Expresser.LAST_CHAR_OPERATOR) && ch == '/') {
                idx = skipRegExp(statement, idx, end);
                lastCharType = Expresser.LAST_CHAR_VALUE;   //  K\Ȃ̂Œl
            }
            /*
             * ʂ̐[ 0 ̏ꍇAZq
             */
            else if (parenthesisDepth == 0) {
                //  ԗD揇ʂ̒ႢZqT
                if ('0' <= ch && ch <= '9' || (lastCharType == Expresser.LAST_CHAR_NUMBER && ch == '.')) {
                    idx = skipToken(statement, idx, end);
                    lastCharType = Expresser.LAST_CHAR_NUMBER;
                }
                else if (ch == ' ' || ch == '\t' || ch == '\r' || ch == '\n') {
                    idx++;
                }
                else {
                    int nOpIdx;
                    int nOpMax = opeDataList.size();
                    boolean findOperator = false;
                    //  ]ʒu̕牉ZqJnĂ邩A`FbN
                    for (nOpIdx = 0; nOpIdx < nOpMax; nOpIdx++) {
                        OperatorData opeData = (OperatorData)opeDataList.get(nOpIdx); 
                        if (opeData.compare(statement, idx, end)) { //  Zq̕񂪈v
                            if (((lastCharType == Expresser.LAST_CHAR_NUMBER || lastCharType == Expresser.LAST_CHAR_VALUE || lastCharType == Expresser.LAST_CHAR_VARIABLE) && opeData.getOpeClass() != OperatorData.OP_CLS_FRONT_UNITY) ||
                                    ((lastCharType == Expresser.LAST_CHAR_NONE || lastCharType == Expresser.LAST_CHAR_OPERATOR) && opeData.getOpeClass() == OperatorData.OP_CLS_FRONT_UNITY)) {
                                //  ]ʒȗO̕A( or ϐ) and ZqOuPZqłȂ
                                //  邢
                                //  ]ʒȗO̕A( or Zq) and ZqOuPZqł
                                if (opePri < opeData.getPriority()) {
                                    //  Zq̕D揇ʂႢII
                                    operator = opeData;
                                    opeIdx = idx;
                                    opePri = opeData.getPriority();
                                } else if (opePri == opeData.getPriority() && opeData.getOpeClass() != OperatorData.OP_CLS_FRONT_UNITY) {
                                    //  OZqƗD揇ʂɂ̂ŎD揇ʒႢ
                                    //  iOuPZq͂̂j
                                    operator = opeData;
                                    opeIdx = idx;
                                    opePri = opeData.getPriority();
                                }
                                if (opeData.getOpeClass() == OperatorData.OP_CLS_BACK_UNITY)
                                    lastCharType = Expresser.LAST_CHAR_VALUE;       //  ZqiuPZqȊOj
                                else
                                    lastCharType = Expresser.LAST_CHAR_OPERATOR;    //  ZqłuPZqȂ̂ŁulvƌȂB
                                idx += opeData.getOperatorChars().length;
                                findOperator = true;
                                break;
                            }
                        }
                    }
                    if (findOperator == false) {
                        if (Character.isUnicodeIdentifierStart(ch) || Character.isJavaIdentifierStart(ch)) {
                            idx = skipToken(statement, idx, end);
                            lastCharType = Expresser.LAST_CHAR_VARIABLE;
                        } else {
                            throw new ExpException(getResString("IllegalCharacter"), opeIdx);
                        }
                    }
                }
            }
            else
                idx++;
        }
        if (parenthesisDepth != 0) {
            throw new ExpException(getResString("UnmatchParenthesis"), idx);
        }
        
        //
        //  Zq IParsedExpression ̃CX^X쐬
        //
        if (operator == null) {
            //
            //  ZqȂ
            //
            
            //  ϐ܂͒萔
            if (('0' <= beginChar && beginChar <= '9') || beginChar == '.') {
                //  萔
                return new WrappedExpression(toValue(statement, begin, end));
            }
            if (beginChar == '\"' || beginChar == '\'') {
                //  萔
                return new WrappedExpression(toStrValue(statement, begin, end));
            }
            if (beginChar == '/') {
                //  K\
                return new WrappedExpression(toRegExpValue(statement, begin, end));
            }
            else {
                //  ϐ
                String variableName = trim(substring(statement, begin, end));
                if (isIdentifier(variableName) == false)
                    throw new ExpException(getResString("IllegalIdentifier", variableName), begin);
                Integer variableId = StringToId.toId(variableName);
                IVariable variable = defaultRuntimeData.getVariable(variableId, false);
                if (variable != null && variable.isConst())        //  ϐOɒ`ꂽ萔łꍇAparseɌvZĂ܂
                    return new WrappedExpression(variable.getValue());
                return new WrappedVariableExpression(variableName, variableId, begin);
            }
        }
        else {
            //
            //  ϐ萔ł͂ȂvZiZqj
            //
            if (operator.getOriginalParser() != null)
                return operator.getOriginalParser().parse(this, statement, begin, end, opeIdx, operator.toString());
            
            //  ZΏۂm
            IParsedExpression operand1Expression = null;
            IParsedExpression operand2Expression = null;
            
            //  IyhiIyhj
            if (operator.getOperator() == OperatorData.OP_PARENTHESIS) {
                ;
            } else if (operator.getOpeClass() == OperatorData.OP_CLS_BIN || operator.getOpeClass() == OperatorData.OP_CLS_BACK_UNITY) {
                if (begin < opeIdx)
                    operand1Expression = parse(statement, begin, opeIdx);
            }

            //  EIyhiIyhj
            if (operator.getOperator() == OperatorData.OP_MEMBER_ACCESS) {
                int opeLen = operator.getOperatorChars().length;
                String identifier = substring(statement, opeIdx + opeLen, end);
                if (isIdentifier(identifier) == false)
                    throw new ExpException(getResString("IllegalIdentifier", identifier), opeIdx + opeLen);
                Integer memberID = StringToId.toId(identifier);
                return new Op_MemberAccessExpression((IParsedExpression)operand1Expression, memberID, opeIdx);
            } else {
                if (operator.getOpeClass() == OperatorData.OP_CLS_BIN || operator.getOpeClass() == OperatorData.OP_CLS_FRONT_UNITY) {
                    int opeLen = operator.getOperatorChars().length;
                    if (opeIdx + opeLen < end) {
                        operand2Expression = parse(statement, opeIdx + opeLen, end);
                    }
                }
            }

            //  PZq̃`FbN
            if (begin != opeIdx) {
                if (operator.getOpeClass() == OperatorData.OP_CLS_FRONT_UNITY)
                    throw new ExpException(getResString("UnnecessaryLeftOperand"), opeIdx);
            }
            if (end != opeIdx + operator.toString().length()) {
                if (operator.getOpeClass() == OperatorData.OP_CLS_BACK_UNITY)
                    throw new ExpException(getResString("UnnecessaryRightOperand"), opeIdx);
            }
                
            if (operator.getOperator() == OperatorData.OP_PARENTHESIS) {
                if (statement[opeIdx] == '(') {
                    //  svȊʂŊĂ̂ŁA͂čČvZ
                    if (opeIdx == begin) {
                        return parse(statement, begin + 1, end - 1);
                    }

                    //  ֐i\bhjĂяo
                    IParsedExpression function = parse(statement, begin, opeIdx);
                    int argStart = opeIdx + operator.getOperatorChars().length;
                    int argEnd = skipParenthesis(statement, opeIdx, end) - 1;
                    IParsedExpression[] arguments = splitFunctionArgs(statement, argStart, argEnd);    //  J}ŕ
                    //  ֐ĂяoZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B
                    return new Op_FunctionCallExpression(function, arguments, opeIdx);
                } else if (statement[opeIdx] == '[') {
                    if (begin != opeIdx) {
                        //  Iy[^̈ʒů͎Jnʒuł͂Ȃzւ̃ANZX
                        IParsedExpression object = parse(statement, begin, opeIdx);
                        IParsedExpression objIndex = parse(statement, opeIdx + operator.getOperatorChars().length, end - 1);
                        //  zANZXZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B
                        return new Op_ArrayAccessExpression(object, objIndex, opeIdx);
                    } else {
                        //  Iy[^̈ʒů͎Jnʒuz̒`
                        return defineArray(statement, opeIdx + 1, end - 1);
                    }
                } else if (statement[opeIdx] == '{') {
                    //  IuWFNg̏
                    return defineObject(statement, opeIdx + 1, end - 1);
                }
                throw new ExpException(getResString("InternalError", "Expresser#parse()", "unknown parenthesis"), opeIdx);    //  Ɍ肪
            } else {
                if (operand1Expression == null && operand2Expression == null)
                    throw new ExpException(getResString("OperandNotFound"), opeIdx);
                
                //  萔͂炩ߌvZĂ܂
                if (operand1Expression != null && operand1Expression.isConst()) {
                    IExpObject object = ((IParsedExpression)operand1Expression).evaluate(defaultRuntimeData); 
                    operand1Expression = new WrappedExpression(object);
                }
                if (operand2Expression != null && operand2Expression.isConst()) {
                    IExpObject object = ((IParsedExpression)operand2Expression).evaluate(defaultRuntimeData); 
                    operand2Expression = new WrappedExpression(object);
                }
                
                //  ϐvĂ̂ɒ萔ɂȂĂȂ`FbN
                /*
                if (operator.isLeftVariable() && (operand1 instanceof IParsedExpression == false))
                    throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), opeIdx);
                if (operator.isRightVariable() && (operand2 instanceof IParsedExpression == false))
                    throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), opeIdx);
                */
                
                IParsedExpression result;
                if (operator.getOperator() == OperatorData.OP_ARI_INC_B) {
                    //uCNgZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B
                    result = new Op_IncrementExpression(operand1Expression, opeIdx, 1);
                } else if (operator.getOperator() == OperatorData.OP_ARI_DEC_B) {
                    //ufNgZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B
                    result = new Op_IncrementExpression(operand1Expression, opeIdx, -1);
                } else if (operator.getOperator() == OperatorData.OP_SUBSTITUTE) {
                    //ZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B
                    result = new Op_SubstituteExpression((IParsedExpression)operand1Expression, operand2Expression, opeIdx);
                } else if (operator.getOperator() == OperatorData.OP_LOG_AND) {
                    //ZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B
                    result = new Op_LogicalAndExpression(operand1Expression, operand2Expression, opeIdx);
                } else if (operator.getOperator() == OperatorData.OP_LOG_OR) {
                    //ZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B
                    result = new Op_LogicalOrExpression(operand1Expression, operand2Expression, opeIdx);
                } else {
                    result = new ParsedExpression(operand1Expression, operand2Expression, operator, opeIdx, this);
                }
                return result;
            }
        }
    }
    
    /**
     * {} ()ɏꂽeIuWFNg𐶐܂<br/>
     * )<br/>
     *   {aaa:0, bbb:"text"}
     * 
     * @param string Ώ
     * @param begin Jnʒu
     * @param end Iʒu
     * @exception ExpException
     */
    public IParsedExpression defineObject(char[] string, int begin, int end) throws ExpException {
        Range[] properties = split(',', string, begin, end);
        int max = properties.length;
        //  Ō̍ڂȂ폜
        if (max >= 1 && (properties[max - 1].getBegin() == properties[max - 1].getEnd()))
            max--;
        
        //  vpeBƂĎׂID̃Xg
        List propertyIdList = new ArrayList();
        //  vpeB̎̃Xg
        List propertyExpressionList = new ArrayList();
        
        //  vpeBƂׂOiIDjƎ񋓂
        for (int idx = 0; idx < max; idx++) {
            Range property = properties[idx];
            if (property.getBegin() != property.getEnd()) {
                Range propertyRange[] = split(':', string, property.getBegin(), property.getEnd());
                if (propertyRange.length != 2)
                    throw new ExpException(getResString("SyntaxError"), property.getBegin());
                Range propertyNameRange = propertyRange[0]; 
                Range propertyExpressionRange = propertyRange[1];
                String propertyName = substring(string, propertyNameRange.getBegin(), propertyNameRange.getEnd());
                if (isIdentifier(propertyName) == false)
                    throw new ExpException(getResString("IllegalIdentifier", propertyName), property.getBegin());
                IParsedExpression propertyExpression = parse(string, propertyExpressionRange);
                
                propertyIdList.add(StringToId.toId(propertyName));
                propertyExpressionList.add(propertyExpression);
            }
        }
        //  propertyIdListpropertyExpressionListgăIuWFNg
        max = propertyIdList.size();
        Integer[] propertyIds = new Integer[max]; 
        IParsedExpression[] propertyExpressions = new IParsedExpression[max];
        
        propertyIdList.toArray(propertyIds);
        propertyExpressionList.toArray(propertyExpressions);
        
        return new ExpObjectInitializer(propertyIds, propertyExpressions);
    }
    
    /**
     * [] (劇)ɏꂽez𐶐܂<br/>
     * )<br/>
     *   [0, "text"]
     * 
     * @param string Ώ
     * @param begin Jnʒu
     * @param end Iʒu
     * @exception ExpException
     */
    public IParsedExpression defineArray(char[] string, int begin, int end) throws ExpException {
        Range[] elements = split(',', string, begin, end);
        int max = elements.length;
        //  Ō̍ڂȂ폜
        if (max >= 1 && (elements[max - 1].getBegin() == elements[max - 1].getEnd()))
            max--;
        
        //  evf̎̃Xg
        List elementsExpressionList = new ArrayList();
        //  evf񋓂XgɊi[
        for (int idx = 0; idx < max; idx++) {
            Range element = elements[idx];
            if (element.getBegin() != element.getEnd()) {
                IParsedExpression propertyExpression = parse(string, element);
                elementsExpressionList.add(propertyExpression);
            } else {
                elementsExpressionList.add(new WrappedExpression(UNDEFINED));
            }
        }
        
        max = elementsExpressionList.size();
        IParsedExpression[] elementsExpressions = new IParsedExpression[max];
        
        elementsExpressionList.toArray(elementsExpressions);
        
        return new ExpArrayInitializer(elementsExpressions);
    }
    
    /**
     * charẑ͈͂當𐶐܂
     * @param string Ώ
     * @param begin Jnʒu
     * @param end Iʒu
     * @return Ώۂɑ΂AJnʒuIʒu܂ł̕
     */
    public static String substring(char[] string, int begin, int end) {
        //  Ő󔒏()
        char beginChar = string[begin];
        while (begin < end && (Character.isSpaceChar(beginChar) || beginChar == '\t' || beginChar == '\r' || beginChar == '\n')) {
            begin++;
            beginChar = string[begin];
        }
        char endChar = beginChar;
        if (begin != end - 1) {
            endChar = string[end - 1];
            while (begin < end && (Character.isSpaceChar(endChar) || endChar == '\t' || endChar == '\r' || endChar == '\n')) {
                end--;
                endChar = string[end - 1];
            }
        }
        return new String(string, begin, end - begin);
        
    }
    
    
    /**
     * ̑Ő󔒕ǂݔ΂܂
     * @param src 
     * @return Ő󔒂菜
     */
    public static String trim(String src) {
        char[] chars = src.toCharArray();
        int idx = 0;
        int max = src.length();
        while (idx < max && (Character.isSpaceChar(chars[idx]) || chars[idx] == '\t' || chars[idx] == '\r' || chars[idx] == '\n'))
            idx++;
        while (idx < max && (Character.isSpaceChar(chars[max - 1]) || chars[max - 1] == '\t' || chars[max - 1] == '\r' || chars[max - 1] == '\n' ))
            max--;
        return String.valueOf(chars, idx, max - idx);
    }
    
    
    /**
     * Xe[gg̒ŁA󔒕ǂݔ΂܂iXy[X, ^u, scj
     * @param script Xe[gg
     * @param begin Jnʒu
     * @param end Iʒu
     * @return nBegin󔒂ǂݔ΂A󔒂łȂŏ̕
     */
    public static int skipWhitespace(char[] script, int begin, int end) {
        int idx = begin;
        while (idx < end) {
            if (Character.isSpaceChar(script[idx]) == false && (script[idx] != '\t') && (script[idx] != '\r') && (script[idx] != '\n')) {
                return idx;
            }
            idx++;
        }
        return end;
    }
    
    
    /**
     * Xe[gg̒ŁANH[głꂽ͈͂ǂݔ΂܂
     * @param script Xe[gg
     * @param begin 񃊃e̊JnʒuiK " ܂ ' ł邱Ɓj
     * @param end Iʒu
     * @return 񃊃ȅIʒu " + 1
     * @exception ExpException 
     */
    public static int skipString(char[] script, int begin, int end) throws ExpException {
        char beginChar = script[begin]; 
        if (beginChar != '\"' && beginChar != '\'') {
            throw new ExpException(getResString("InternalError", "Expresser#skipString()"), begin);
        }
        
        int idx = begin + 1;
        while (idx < end) {
            char ch = script[idx];
            if (ch == '\n') {
                throw new ExpException(getResString("StringHasNotEnded"), idx);
            }
            else if (ch == beginChar) {
                return idx + 1;
            }
            else if (ch == '\\')
                idx += 2;
            else
                idx++;
        }
        throw new ExpException(getResString("StringHasNotEnded"), begin);
    }
    
    /**
     * Xe[gg̒ŁAK\ǂݔ΂܂
     * @param script
     * @param begin JnʒuiK / ł邱Ɓj
     * @param end Iʒu
     * @return K\̏I / ̈ʒu + 1
     * @throws ExpException
     */
    public static int skipRegExp(char[] script, int begin, int end) throws ExpException {
        char beginChar = script[begin]; 
        if (beginChar != '/') {
            throw new ExpException(getResString("InternalError", "Expresser#skipRegExp()"), begin);
        }
        
        int idx = begin + 1;
        while (idx < end) {
            char ch = script[idx];
            if (ch == '\n') {
                throw new ExpException(getResString("RegexHasNotEnded"), idx);
            }
            else if (ch == beginChar) {
                return idx + 1;
            }
            else if (ch == '\\')
                idx += 2;
            else
                idx++;
        }
        throw new ExpException(getResString("RegexHasNotEnded"), begin);
    }

    /**
     * Xe[gg̒ŁAʂłꂽ͈͂ǂݔ΂܂
     * @param script
     * @param begin JnʒuiK (, [, { ł邱Ɓj
     * @param end Iʒu
     * @return ʂ̏Iʒu + 1
     */
    public static int skipParenthesis(char[] script, int begin, int end) throws ExpException {
        char endChar;
        switch (script[begin]) {
        case '(':
            endChar = ')';
            break;
        case '[':
            endChar = ']';
            break;
        case '{':
            endChar = '}';
            break;
        default:
            throw new ExpException(getResString("InternalError", "Expresser#skipParenthesis()", "unknown parenthesis"), begin);
        }

        int idx = begin + 1;
        while (idx < end) {
            char ch = script[idx];
            if (ch == '(' || ch == '[' || ch == '{')
                idx = skipParenthesis(script, idx, end);
            else if (ch == endChar)
                return idx + 1;
            else if (ch == '\"' || ch == '\'')
                idx = skipString(script, idx, end);
//          else if (ch == '/')
//              idx = skipRegExp(script, idx, end);
            else
                idx++;
        }
        throw new ExpException(getResString("UnmatchParenthesis"), begin);
    }

    /**
     * Xe[gg̒ŁAPPǂݔ΂܂
     * @param script
     * @param begin Jnʒu
     * @param end P̏Iʒu + 1
     * @return ʂ̏Iʒu + 1
     */
    public int skipToken(char[] script, int begin, int end) {
        char firstChar = script[begin];
        if (firstChar < '0' || (firstChar > '9' && firstChar < 'A') ||  (firstChar > 'Z' && firstChar < 'a') || (firstChar > 'z' && firstChar < 0x80)) {
            if (firstChar != '$' && firstChar != '_') { //  $  _ ͋LƂĈȂ
                //  L͉ZqƂĈBAt@xbgn܂鉉Zq͂ł͒ʏ̃g[NƓ悤Ɉ
                int nOpIdx;
                int nOpMax = opeDataList.size();
                for (nOpIdx = 0; nOpIdx < nOpMax; nOpIdx++) {
                    OperatorData opeData = (OperatorData)opeDataList.get(nOpIdx); 
                    if (opeData.compare(script, begin, end)) {
                        return begin + opeData.length();
                    }
                }
            }
        }
        //  (, [, {, ", 'ǂݔ΂ׂH
        
        //  ̔͊ȈՂłBrŕςȕĂĂX[܂B̏ꍇAɌĂяo toValue() \bhŃG[ƂȂ܂B
        boolean isNumber = ((firstChar >= '0' && firstChar <= '9') || firstChar == '.');
        int idx = begin;
        while (idx < end) {
            char ch = script[idx];
            if (isNumber && (ch == 'e' || ch == 'E') && (idx + 1 < end))
                idx += 2;
            else if (Character.isUnicodeIdentifierPart(ch) || Character.isJavaIdentifierPart(ch))    
                idx++;
            else if (ch > 0xFF)    
                idx++;
            else if (ch == '.') {
                if (isNumber == false)
                    return idx;
                idx++;
            } else
                return idx;
        }
        return idx;
    }
    
    
    /**
     * begin ʒû̒PԂ܂B
     * @param script XNvg
     * @param begin Jnʒu
     * @param end Iʒu
     * @return P
     */
    public String nextToken(char[] script, int begin, int end) {
        int tokenEnd = skipToken(script, begin, end);
        return new String(script, begin, tokenEnd - begin); 
    }
    
    /**
     * ʒu̕񂪉Zqƈv邩܂B
     * @param script XNvg
     * @param begin Jnʒu
     * @param end Iʒu
     * @return Zqłꍇ true
     */
    public boolean isOperator(char[] script, int begin, int end) {
        int nOpIdx;
        int nOpMax = opeDataList.size();
        for (nOpIdx = 0; nOpIdx < nOpMax; nOpIdx++) {
            OperatorData opeData = (OperatorData)opeDataList.get(nOpIdx); 
            if (opeData.compare(script, begin, end)) {
                return true;
            }
        }
        return false;
    }
    

    /**
     * w肳ꂽŎw肳ꂽXNvg͈̔͂𕪊܂
     * @param splitChar 镶
     * @param script XNvg
     * @param begin Jnʒu
     * @param end Iʒu
     * @return ꂽ͈̓IuWFNg̔z
     * @throws ExpException
     */
    public static Range[] split(char splitChar, char[] script, int begin, int end) throws ExpException {
        List resultList = new ArrayList();
        int idx = begin;
        int beginIdx = idx;
        int endIdx;
        while (idx < end) {
            char ch = script[idx];
            if (ch == splitChar) {
                endIdx = idx;
                //  Ő󔒂폜
                while (Character.isSpaceChar(script[beginIdx]) && beginIdx < endIdx)
                    beginIdx++;
                while (Character.isSpaceChar(script[endIdx - 1]) && beginIdx < endIdx)
                    endIdx--;

                resultList.add(new Range(beginIdx, endIdx));
                idx++;
                beginIdx = idx;
            } else if (ch == '(' || ch == '{' || ch == '[') {
                idx = skipParenthesis(script, idx, end);
            } else if (ch == '"' || ch == '\'') {
                idx = skipString(script, idx, end);
            } else {
                idx++;
            }
        }
        endIdx = idx;
        //  Ő󔒂폜
        while (Character.isSpaceChar(script[beginIdx]) && beginIdx < endIdx)
            beginIdx++;
        while (Character.isSpaceChar(script[endIdx - 1]) && beginIdx < endIdx)
            endIdx--;

        if (beginIdx <= endIdx)
            resultList.add(new Range(beginIdx, endIdx));

        //  List ziRange[]jɕϊ
        Range[] result = new Range[resultList.size()];
        for (idx = 0; idx < result.length; idx++)
            result[idx] = (Range)(resultList.get(idx)); 
        return result;
    }
    
    /**
     * ̈J}ŕ܂
     * 
     * @param arguments Q
     * @param begin Jnʒu
     * @param end Iʒu
     * @return ꂽivZς݁j
     * @throws Exception vZ̎sG[
     */
    public IParsedExpression[] splitFunctionArgs(char[] arguments, int begin, int end) throws ExpException {
        List list = new ArrayList();
        int argBegin = begin;
        
        int max = end;
        int idx = begin;
        while (idx < max) {
            char ch = arguments[idx];
            if (ch == '(' || ch == '[' || ch == '{')
                idx = skipParenthesis(arguments, idx, end); //  ʂ͓ǂݔ΂
            else if (ch == '\"' || ch == '\'')
                idx = skipString(arguments, idx, end);      //  ǂݔ΂
            else {
                if (arguments[idx] == ',') {
                    //  P]
                    Object oArg = parse(arguments, argBegin, idx);
                    list.add(oArg);
                    argBegin = idx + 1;
                }
                idx++;
            }
            
        }
        if (argBegin != max) {
            Object oArg = parse(arguments, argBegin, max);
            list.add(oArg);
        }
        //  IParsedExpression̔z
        max = list.size();
        IParsedExpression[] result = new IParsedExpression[max];
        for (idx = 0; idx < max; idx++) {
            result[idx] = (IParsedExpression)list.get(idx);
        }
        return result;
    }
    
    /**
     * Xe[gg̈ꕔ𐮐^܂͎^ɕϊ܂
     * @param sStatement Xe[gg
     * @param begin Jnʒu
     * @param end Iʒu
     * @return ϊꂽIuWFNg
     * @throws ExpException ƂĔFłȂO
     */
    public static _Double toValue(char[] statement, int begin, int end) throws ExpException {
        long longValue = 0;
        double doubleValue = 0;
        double baseValue = 1;
        boolean doubleFlag = false;
        boolean minusFlag = false;
        int radix = 10;
        int idx = begin;
        
        //  擪 0 ̏ꍇύX
        if (statement[idx] == '0' && end > idx + 1) {
            if ((statement[idx + 1] == 'x' || statement[idx + 1] == 'X')) {
                //  PUi
                radix = 16;
                idx += 2;
            } else if ( statement[idx + 1] == '.') {
                //  ςPOiij
            } else {
                //  Wi
                radix = 8;
            }
        }
        for (; idx < end; idx++) {
            char ch = statement[idx];
            if ('0' <= ch && ch <= '9') {
                if (doubleFlag == false) {
                    int value = (ch - '0');
                    if (value >= radix)
                        throw new ExpException(getResString("IllegalNumericRepresentation", new String(statement, begin, end - begin)), idx);
                        
                    longValue *= radix;
                    longValue += (ch - '0');
                }
                else {
                    doubleValue *= radix;
                    doubleValue += (ch - '0');
                    baseValue *= radix;
                }
            } else if ('a' <= ch && ch <= 'f' && radix == 16) {
                longValue *= radix;
                longValue += (10 + ch - 'a');
            } else if ('A' <= ch && ch <= 'F' && radix == 16) {
                longValue *= radix;
                longValue += (10 + ch - 'A');
            } else if (ch == '.') {
                if (doubleFlag)
                    throw new ExpException(getResString("IllegalNumericRepresentation", new String(statement, begin, end - begin)), idx);
                if (radix != 10)
                    throw new ExpException(getResString("IllegalNumericRepresentation", new String(statement, begin, end - begin)), idx);
                doubleFlag = true;
                doubleValue = longValue;
            }
            else if (ch == '-') {
                if (idx == begin)
                    minusFlag = true;
                else
                    throw new ExpException(getResString("IllegalNumericRepresentation", new String(statement, begin, end - begin)), idx);
            }
            else if (ch == 'e' || ch == 'E') {
                //  w
                try {
                    int exp = ((_Double)toValue(statement, idx + 1, end)).intValue();
                    if (doubleFlag)
                        return new _Double(doubleValue / baseValue * Math.pow(radix, exp));
                    else
                        return new _Double(longValue * Math.pow(radix, exp));
                }
                catch (Exception e) {
                    throw new ExpException(getResString("IllegalNumericRepresentation", new String(statement, begin, end - begin)), idx + 1);
                }
            }
            else {
                throw new ExpException(getResString("IllegalNumericRepresentation", new String(statement, begin, end - begin)), idx);
            }
        }
        if (minusFlag) {
            longValue = -longValue;
            doubleValue = -doubleValue;
        }
        if (doubleFlag) {
            if (doubleValue == 0 && minusFlag)
                return new _Double(-0.0);
            return new _Double(doubleValue / baseValue);
        } else {
            if (longValue == 0 && minusFlag)
                return new _Double(-0.0);
            return new _Double(longValue);
/*            
            if (Integer.MIN_VALUE <= longValue && longValue <= Integer.MAX_VALUE)
                return new _Integer((int)longValue);
            else
                return new _Long(longValue);
*/                
        }
    }
    
    
    /**
     * \當IuWFNg𐶐܂
     * @param sStatement Xe[gg
     * @param begin Jnʒu
     * @param end Iʒu
     * @return ϊꂽIuWFNg
     * @throws ExpException
     */
    private IExpObject toStrValue(char[] statements, int begin, int end) throws ExpException {
        if (begin >= end)
            throw new ExpException(getResString("StringHasNotEnded"), begin);
        if (statements[begin] != '\"' && statements[begin] != '\'')
            throw new ExpException(getResString("InternalError", "Expresser#toStrValue()"), begin);
        if (statements[begin] != statements[end - 1])
            throw new ExpException(getResString("StringHasNotEnded"), begin);
        
        StringBuffer result = new StringBuffer();
        int idx = begin + 1;
        int max = end - 1;
        while (idx < max) {
            char ch = statements[idx];
            if (ch != '\\') {
                result.append(ch);
                idx++;
            } else {
                if (idx == max - 1)
                    throw new ExpException(getResString("StringHasNotEnded"), begin);
                char ch2 = statements[idx + 1];
                switch (ch2) {
                case 'b':
                    result.append('\b');
                    break;
                case 't':
                    result.append('\t');
                    break;
                case 'n':
                    result.append('\n');
                    break;
                case 'f':
                    result.append('\f');
                    break;
                case 'r':
                    result.append('\r');
                case '0':
                    result.append('\0');
                    break;
                case '\\':
                    result.append('\\');
                    break;
                case '\"':
                    result.append('\"');
                    break;
                case '\'':
                    result.append('\'');
                    break;
                case 'u':
                    if (idx + 6 > end)
                        throw new ExpException(getResString("InvalidEscapeSequence"), idx);
                    result.append(hexToChar(statements, idx + 2));
                    idx += 4;
                    break;
                    
                default:
                    throw new ExpException(getResString("InvalidEscapeSequence"), idx);
                }
                idx += 2;
            }
        }
        
        return new _String(result.toString());
    }

    /**
     * K\琳K\IuWFNg𐶐܂
     * @param sStatement Xe[gg
     * @param begin Jnʒu
     * @param end Iʒu
     * @return ϊꂽIuWFNg
     * @throws ExpException
     */
    private IExpObject toRegExpValue(char[] statements, int begin, int end) throws ExpException {
        if (begin >= end)
            throw new ExpException(getResString("RegexHasNotEnded"), begin);
        if (statements[begin] != '/')
            throw new ExpException(getResString("InternalError", "Expresser#toRegExpValue()"), begin);
        if (statements[end - 1] != '/')
            throw new ExpException(getResString("RegexHasNotEnded"), begin);
        
        StringBuffer result = new StringBuffer();
        int idx = begin + 1;
        int max = end - 1;
        while (idx < max) {
            char ch = statements[idx];
            if (ch != '\\') {
                result.append(ch);
                idx++;
            } else {
                if (idx == max - 1)
                    throw new ExpException(getResString("StringHasNotEnded"), begin);
                char ch2 = statements[idx + 1];
                switch (ch2) {
                case 'b':
                    result.append('\b');
                    break;
                case 't':
                    result.append('\t');
                    break;
                case 'n':
                    result.append('\n');
                    break;
                case 'f':
                    result.append('\f');
                    break;
                case 'r':
                    result.append('\r');
                case '0':
                    result.append('\0');
                    break;
                case '\\':
                    result.append('\\');
                    break;
                case '\"':
                    result.append('\"');
                    break;
                case '\'':
                    result.append('\'');
                    break;
                case 'u':
                    if (idx + 6 > end)
                        throw new ExpException(getResString("InvalidEscapeSequence"), idx);
                    result.append(hexToChar(statements, idx + 2));
                    idx += 4;
                    break;
                    
                default:
                    throw new ExpException(getResString("InvalidEscapeSequence"), idx);
                }
                idx += 2;
            }
        }
        
        return new ExpRegExp(result.toString(), "");
    }
    
    
    /**
     * 0`9, a`f, A`F ō\S char ^𐶐܂
     * @param statements Xe[gg
     * @param begin Jnʒu
     * @return ꂽP
     * @throws ExpException
     */
    public char hexToChar(char[] statements, int begin) throws ExpException {
        char result = 0;
        int max = begin + 4;
        for (int idx = begin; idx < max; idx++) {
            byte by;
            if ('0' <= statements[idx] && statements[idx] <= '9')
                by = (byte)(statements[idx] - '0');
            else if ('a' <= statements[idx] && statements[idx] <= 'f')
                by = (byte)(statements[idx] - 'a' + 10);
            else if ('A' <= statements[idx] && statements[idx] <= 'F')
                by = (byte)(statements[idx] - 'A' + 10);
            else
                throw new ExpException(getResString("IllegalCharacter"), idx);
            
            result <<= 4;
            result |= by; 
        }
        return result;
    }
    
    
    
    /**
     * ʎqϐ֐ƂĐ邩`FbN܂
     * 
     * @param identifier ʎq
     * @return ʎqƂĐꍇ true
     */
    public boolean isIdentifier(String identifier) {
        int max = identifier.length(); 
        if (max == 0)
            return false;
        if (reservedWords.get(identifier) != null)
            return false;
        char ch = identifier.charAt(0);
        if (!Character.isUnicodeIdentifierStart(ch) && !Character.isJavaIdentifierStart(ch))
            return false;
        for (int idx = 1; idx < max; idx++) {
            ch = identifier.charAt(idx);
            if (!Character.isUnicodeIdentifierPart(ch) && !Character.isJavaIdentifierPart(ch))
                return false;
        }
        return true;
    }
    
    /**
     * v~eBu^Cv(int, doubleƂc)ExpInteger, ExpDoubleɕϊ܂<br>
     * v~eBu^Cv^ȊO͂̂܂ܒlԂ
     * 
     * @param value JavãtNVAPI߂Ăl
     * @param type JavãtNVAPI߂Ă^
     * @return Expresser őΉ^ɕϊꂽIuWFNg
     */
    public static IExpObject convertPrimitiveType(Object value, Class type) throws ExpException {
        if (type == int.class)
            return new _Integer(((Integer)value).intValue());
        else if (type == double.class)
            return new _Double(((Double)value).doubleValue());
        else if (type == long.class)
            return new _Long(((Long)value).longValue());
        else if (type == byte.class)
            return new _Byte(((Byte)value).byteValue());
        else if (type == short.class)
            return new _Short(((Double)value).shortValue());
        else if (type == double.class)
            return new _Float(((Float)value).floatValue());
        else if (type == char[].class)  //  char ̔z͕񈵂ɂĂ܂
            return new ExpString(String.valueOf((char[])value));
        else if (type == char.class) {
            return new ExpString(String.valueOf(value));
        } else
            return new JavaObject(value);
    }
    
    
    /**
     * ZqZbg߂܂
     * 
     * @param idx ZqZbg̃CfbNX
     * @return ZqZbg
     */
    public IOperatorSet getOperatorSet(int idx) {
        return (IOperatorSet)operatorSetList.get(idx);
    }

    /**
     * ZqZbg̃Xg߂܂B
     * @return ZqZbg̃Xg
     */
    public List getOperatorSetList() {
        return operatorSetList;
    }
    
    /**
     * Expresser ɓo^ꂽZqZbg̒IyhɑΉZqZbg܂B
     * @param operand ZΏ
     * @return ZΏۂɑΉZqZbg
     */
    public IOperatorSet searchOperatorSet(Object operand) {
        IOperatorSet opeSet;
        //  pnbVe[uɓo^ꂽ̂猟
        if (operand != null)
            opeSet = (IOperatorSet)operatorSetTable.get(operand.getClass());
        else
            return (IOperatorSet)operatorSetList.get(0);
            
        if (opeSet != null)
            return opeSet;
        
        //  operatorSetList 猟
        int setMax = operatorSetList.size();
        for (int setIdx = setMax - 1; setIdx >= 0; setIdx--) {
            opeSet = (IOperatorSet)operatorSetList.get(setIdx);
            Class[] types = opeSet.targetType();
            int typeMax = types.length;
            for (int typeIdx = 0; typeIdx < typeMax; typeIdx++) {
                if (types[typeIdx].isInstance(operand)) {
                    operatorSetTable.put(operand.getClass(), opeSet);    //pnbVe[u֓o^    
                    return opeSet;
                }
            }
        }
        return null;
    }
    
    /**
     * VZqZbgǉ܂
     * 
     * @param operatorSet VZqZbg
     */
    public void setOperatorSet(IOperatorSet operatorSet) {
        operatorSetList.add(operatorSet);
    }

    /**
     * ftHg̃^Cf[^Ԃ܂
     * @return ftHg̃^Cf[^
     */
    public RuntimeData getDefaultRuntimeData() {
        return defaultRuntimeData;
    }
    
    /**
     * ftHg̃^Cf[^ݒ肵܂
     * @param runtime ^Cf[^
     * 
     */
    public void setDefaultRuntimeData(RuntimeData runtime) {
        defaultRuntimeData = runtime;
    }
    
    /**
     * Iy[^f[^ǉ܂
     * @param operatorData Zqf[^
     */
    public void addOpeData(OperatorData operatorData) {
        String opeString = String.valueOf(operatorData.getOperatorChars()); 
        
        /* ʎqƂĔFł镶n܂鉉Zq͗\Ƃēo^*/
        if (Character.isUnicodeIdentifierStart(opeString.charAt(0)) || Character.isJavaIdentifierPart(opeString.charAt(0)))
            addReservedWord(opeString);

        /* ZqƂēo^ */
        int max = opeDataList.size();
        for (int idx = 0; idx < max; idx++) {
            OperatorData workOperatorData = (OperatorData)opeDataList.get(idx);
            if (workOperatorData.getOperatorChars().length < operatorData.getOperatorChars().length) {
                opeDataList.add(idx, operatorData);
                return;
            }
        }
        opeDataList.add(operatorData);
        
    }
    
    /**
     * o^Ă鉉Zq̒wIDZqf[^܂
     * @param operator OperatorData.OPE_**
     * @return Iy[^f[^
     */
    public OperatorData findOpeData(int operator) {
        int max = opeDataList.size();
        for (int idx = 0; idx < max; idx++) {
            OperatorData opeData = (OperatorData)opeDataList.get(idx);
            if (opeData.getOperator() == operator) {
                return opeData;
            }
        }
        return null;
    }
    
    /**
     * P\Ƃēo^܂<br/>
     * isIdentifier() falseԂ悤ɂȂ܂B 
     * @param reservedWord \Ƃēo^P
     */
    public void addReservedWord(String reservedWord) {
        reservedWords.put(reservedWord, "");
    }
    
    /**
     * IbZ[WɑΉ\[Xoh擾܂
     * @return \[Xoh
     */
    public static DynaResourceBundle getResource() {
        if (resource == null)
            resource = new DynaResourceBundle(ResourceBundle.getBundle(RESOURCE_NAME));
        return resource;
    }
    
    /**
     * L[烍[PɑΉbZ[W擾܂
     * @param key L[
     * @return bZ[W
     */
    public static String getResString(String key) {
        return getResource().getString(key);
    }

    /**
     * L[烍[PɑΉbZ[W擾܂
     * @param key L[
     * @param params up[^̔z
     * @return bZ[W
     */
    public static String getResString(String key, Object[] params) {
        return getResource().getString(key, params);
    }

    /**
     * L[烍[PɑΉbZ[W擾܂
     * @param key L[
     * @param param1 up[^1
     * @return bZ[W
     */
    public static String getResString(String key, Object param1) {
        return getResource().getString(key, param1);
    }
    
    /**
     * L[烍[PɑΉbZ[W擾܂
     * @param key L[
     * @param param1 up[^1
     * @param param2 up[^2
     * @return bZ[W
     */
    public static String getResString(String key, Object param1, Object param2) {
        return getResource().getString(key, param1, param2);
    }

    /**
     * L[烍[PɑΉbZ[W擾܂
     * @param key L[
     * @param param1 up[^1
     * @param param2 up[^2
     * @param param3 up[^3
     * @return bZ[W
     */
    public static String getResString(String key, Object param1, Object param2, Object param3) {
        return getResource().getString(key, param1, param2, param3);
    }

    /**
     * L[烍[PɑΉbZ[W擾܂
     * @param key L[
     * @param param1 up[^1
     * @param param2 up[^2
     * @param param3 up[^3
     * @param param4 up[^4
     * @return bZ[W
     */
    public static String getResString(String key, Object param1, Object param2, Object param3, Object param4) {
        return getResource().getString(key, param1, param2, param3, param4);
    }

    /**
     * Expresser NXp̃hCo[\bh
     * @param args
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {
        System.out.println("jcalc version 0.02 2005");
/*
        Package[] packages = Package.getPackages();
        for (int n = 0; n < packages.length; n++) {
            System.out.println(packages[n].getName());
        }
*/         
        Expresser expresser = new Expresser();
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        String statement = reader.readLine();
        while (statement.equals(".") == false) {
            try {
                if (statement.length() != 0)
                    System.out.println(" = " + expresser.evaluate(expresser.getDefaultRuntimeData(), statement));
            } catch (ExpException ce) {
                System.out.println(statement);
                int max = ce.getPosition();
                for (int idx = 0; idx < max; idx++)
                    System.out.print("-");
                System.out.println("^");
                System.out.println(ce.getMessage());
                
                ce.printStackTrace();
            }
            statement = reader.readLine();
        }
    }
}
