package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * IuWFNg܂BiVIuWFNg𐶐܂j<br/>
 * <br/>
 * 쐬: 2005/03/06
 * 
 * @author m.matsubara
 */
public class ExpArrayInitializer implements IParsedExpression {
    private IParsedExpression[] elementsExpression;
    
    public ExpArrayInitializer(IParsedExpression[] elementsExpressions) {
        this.elementsExpression = elementsExpressions;
    }
    

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#isUsingVariablejava.lang.Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int result = 0;
        int max = elementsExpression.length;
        for (int idx = 0; idx < max; idx++) {
            result += elementsExpression[idx].isUsingVariable(id);
        }
        return result;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evaluate(RuntimeData runtime) throws ExpException {
        int max = elementsExpression.length;
        ExpArray result = new ExpArray(max);
        for (int idx = 0; idx < max; idx++) {
            IExpObject object = elementsExpression[idx].evaluate(runtime);
            result.putProperty(idx, object);
        }
        return result;
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalRef(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException {
        throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), -1);
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalTargetObject(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#isConst()
     */
    public boolean isConst() {
        return false;
    }
}
