package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;

/**
 * ֐Ăяo̎\܂B<br/>
 * ֐ĂяoZqOperatorSetł͂ȂpIParsedExpressionIuWFNgɂď܂B<br/> 
 * <br/>
 * 쐬: 2005/07/29
 * 
 * @author m.matsubara
 */
public class Op_FunctionCallExpression implements IParsedExpression {
    private IParsedExpression functionExpression;
    private IParsedExpression[] argumentsExpression;
    private int opeIdx;
    
    
    public Op_FunctionCallExpression(IParsedExpression functionExpression, IParsedExpression[] argumentsExpression, int opeIdx) {
        this.functionExpression = functionExpression;
        this.argumentsExpression = argumentsExpression;
        this.opeIdx = opeIdx;
    }
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isUsingVariable(java.lang.Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int count = functionExpression.isUsingVariable(id);
        int max = argumentsExpression.length;
        for (int idx = 0; idx < max; idx++)
            count += argumentsExpression[idx].isUsingVariable(id);
        
        return count;
    }

    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evaluate(RuntimeData runtime) throws ExpException {
        try {
            //  ֐IuWFNgo
            IExpObject functionObject = functionExpression.evaluate(runtime);
            if (functionObject instanceof IFunction == false)
                throw new ExpException(Expresser.getResString("NotCallableObject"), opeIdx);
            IExpObject thisObject = functionExpression.evalTargetObject(runtime);
            
            IFunction function = (IFunction)functionObject;
            //  vZ
            int max = argumentsExpression.length;
            IExpObject[] arguments = new IExpObject[max];
            for (int idx = 0; idx < max; idx++)
                arguments[idx] = argumentsExpression[idx].evaluate(runtime);

            //  ֐̌Ăяo
            IExpObject result = function.callFunction(runtime, thisObject, arguments);
            return result;
        } catch (ExpException ee) {
            if (ee.getPosition() < 0)
                ee.setPosition(opeIdx);
            throw ee;
        }
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalRef(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException {
        throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), -1);
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalTargetObject(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#isConst()
     */
    public boolean isConst() {
        return false;
    }

}
