package jp.gr.java_conf.matsubara.expresser.type;

import java.util.List;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;

/**
 * IuWFNg̃o[ێ܂B<br/>
 * <br/>
 * 쐬: 2005/02/06
 * 
 * @author m.matsubara
 */
public class ExpObjectMember implements IExpObject, IVariable, IFunction {
    private IExpObject object;
    private Integer memberId;
    private int index;
    
    public ExpObjectMember(IExpObject object, Integer memberId) {
//      if (object == null)
//          throw new ExpException(Expresser.getResString("NullObject"), -1);
        this.object = object;
        this.memberId = memberId;
        this.index = 0;
    }
        
    public ExpObjectMember(IExpObject object, int index) {
//      if (object == null)
//          throw new ExpException(Expresser.getResString("NullObject"), -1);
        this.object = object;
        this.memberId = null;
        this.index = index;
    }

    /**
     * @return object ߂܂B
     */
    public IExpObject getObject() {
        return object;
    }
    /**
     * @param object object ݒB
     */
    public void setObject(IExpObject object) {
        this.object = object;
    }
    
    /**
     * \bȟĂяo܂Bio\bhłꍇj
     * 
     * @param runtime ^Cf[^
     * @param thisObject thisIuWFNg(null͓̎objectgp܂)
     * @param arguments ID̔ziIntegerj
     * @return ֐̎s
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments) throws ExpException {

        Object memberObj;
        if (memberId != null)
            memberObj = object.getProperty(memberId);
        else
            memberObj = object.getProperty(index);
        
        try {
            IFunction function = (IFunction)memberObj;    //  ClassCastException N\
            if (thisObject != Expresser.UNDEFINED)
                return function.callFunction(runtime, thisObject, arguments);   //  RXgN^
            else
                return function.callFunction(runtime, object, arguments);   //  \bhĂяo
        } catch (ClassCastException cce) {
            throw new ExpException(Expresser.getResString("NotCallableObject"), -1); 
        }
    }
    
    /**
     * ̃otB[hłꍇAl擾
     */
    public IExpObject getValue() throws ExpException {
        if (memberId != null)
            return object.getProperty(memberId);
        else
            return object.getProperty(index);
    }
    
    /**
     * ̃otB[hłꍇAlݒ肷
     */
    public void setValue(IExpObject value) throws ExpException {
        if (memberId != null)
            object.putProperty(memberId, value);
        else
            object.putProperty(index, value);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IVariable#isConst()
     */
    public boolean isConst() throws ExpException {
        return false;
    }
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IVariable#setConst(boolean)
     */
    public void setConst(boolean bConst) throws ExpException {
        throw new ExpException(Expresser.getResString("NotSetConst"), -1);
    }
    
    /**
     * w肳ꂽo[폜
     * @return 폜ꂽvpeB̕ێĂl
     * @throws ExpException
     */
    public IExpObject deleteMember() throws ExpException {
        if (memberId != null)
            return object.deleteProperty(memberId);
        else {
            IExpObject result = object.getProperty(index);
            object.putProperty(index, null);
            return result;
        }
    }

    public IExpObject callFunction(RuntimeData runtime, Object thisObject, Object[] arguments) throws ExpException {
        // TODO Auto-generated method stub
        return null;
    }

    public IExpObject getProperty(Integer id) throws ExpException {
        // TODO Auto-generated method stub
        return null;
    }

    public void putProperty(Integer id, IExpObject value) throws ExpException {
        // TODO Auto-generated method stub
        
    }

    public IExpObject getProperty(int index) throws ExpException {
        // TODO Auto-generated method stub
        return null;
    }

    public void putProperty(int index, IExpObject value) throws ExpException {
        // TODO Auto-generated method stub
        
    }

    public boolean isProperty(Integer id, boolean searchPrototype) throws ExpException {
        // TODO Auto-generated method stub
        return false;
    }

    public IExpObject deleteProperty(Integer id) throws ExpException {
        // TODO Auto-generated method stub
        return null;
    }

    public List getConstructorList() {
        // TODO Auto-generated method stub
        return null;
    }

    public IVariable getVariable(Integer id) {
        // TODO Auto-generated method stub
        return null;
    }

    public IVariable getVariable(int index) {
        // TODO Auto-generated method stub
        return null;
    }

    public Integer[] enumProperty() {
        // TODO Auto-generated method stub
        return null;
    }
}
