package jp.gr.java_conf.matsubara.expresser.type.constructor;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpBoolean;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;

/**
 * Boolean^̃RXgN^łB<br/>
 * <br/>
 * 쐬: 2005/05/03
 * 
 * @author m.matsubara
 */

public class ExpBoolean_constructor extends ExpFunctionBase {
    /**
     * Boolean^̃RXgN^𐶐܂B 
     * @throws ExpException
     */
    public ExpBoolean_constructor() throws ExpException {
        super("Boolean", 1);
        putProperty(StringToId.toId("prototype"), ExpBoolean.getPrototype());
    }


    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length >= 1) {
            if (thisObject != Expresser.UNDEFINED) {  //  RXgN^Ăяo̔
                if (arguments[0].getClass() == _Boolean.class)
                    return new ExpBoolean(((_Boolean)arguments[0]).booleanValue());
                else {
                    ITypeConverter typeConverter = runtime.getTypeConverter();
                    _Boolean bool = typeConverter.toBoolean(runtime, arguments[0]) ;
                    return new ExpBoolean(bool.booleanValue());
                }
            } else {
                ITypeConverter typeConverter = runtime.getTypeConverter();
                return typeConverter.toBoolean(runtime, arguments[0]);
            }
        } else {
            return new ExpBoolean(false);
        }
        
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        if (id.intValue() == ExpObject_constructor.propertyId$prototype.intValue())
            return ExpBoolean.getPrototype();
        return super.getProperty(id);
    }
}
