package jp.gr.java_conf.matsubara.expresser.type.constructor;

import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpError;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * Object^̃RXgN^łB<br/>
 * <br/>
 * 쐬: 2005/05/01
 * 
 * @author m.matsubara
 */

public class ExpError_constructor extends ExpFunctionBase {
    private static final Integer property$message = StringToId.toId("message");
    private static final Integer property$name = StringToId.toId("name");
    
    
    /**
     * Error^̃RXgN^𐶐܂B 
     * @throws ExpException
     */
    public ExpError_constructor() throws ExpException {
        super("Error", 1);
        putProperty(StringToId.toId("prototype"), ExpError.getPrototype());
    }


    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        IExpObject message = new _String("");
        if (arguments.length >= 1) 
            message = arguments[0];
        ExpObject result = new ExpError(message);
        ITypeConverter typeConverter = runtime.getTypeConverter();
        result.putProperty(property$message, typeConverter.toString(runtime, message));
        result.putProperty(property$name, new _String("Error"));
        
        return result;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        if (id.intValue() == ExpObject_constructor.propertyId$prototype.intValue())
            return ExpObject.getPrototype();
        return super.getProperty(id);
    }
}
