package jp.gr.java_conf.matsubara.expresser.type.property;

import java.util.Date;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpDate;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;



/**
 * Array^ sort() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/08
 * 
 * @author m.matsubara
 */

public class Array__sort extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("sort");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Array__sort() throws ExpException {
        super("sort", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        IArray value = (IArray)thisObject;
        if (arguments.length >= 1) {
            sort(runtime, value, (IFunction)(arguments[0]));
        } else {
            sort(runtime, value, null);
        }
        return value;
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Array__sort();
        return instance;
    }
    /**
     * z̃\[gs܂B
     * @param runtime ^Cf[^
     * @param array \[gΏۂ̔z
     * @param compareFunction rp̊֐(null̏ꍇftHg삪gp)
     */
    public void sort(RuntimeData runtime, IArray array, IFunction compareFunction) throws ExpException {
        int length = array.length();
        sort(runtime, array, 0, length - 1, compareFunction);
    }
    
    /**
     * z̃\[gs܂B
     * @param runtime ^Cf[^
     * @param array \[gΏۂ̔z
     * @param minIdx \[gsz̍ŏY
     * @param maxIdx \[gsz̍őY
     * @param compareFunction rp̊֐(null̏ꍇftHg삪gp)
     * @throws ExpException
     */
    public void sort(RuntimeData runtime, IArray array, int minIdx, int maxIdx, IFunction compareFunction) throws ExpException {
        IExpObject swap;
        
        if (minIdx == maxIdx)
            return;
        
        if (minIdx + 1 == maxIdx) {
            if (compare(runtime, array.getProperty(minIdx), array.getProperty(maxIdx), compareFunction) > 0) {
                //  ľ
                swap = array.getProperty(minIdx);
                array.putProperty(minIdx, array.getProperty(maxIdx));
                array.putProperty(maxIdx, swap);
            }
            return;
        }
        
        //  ̃CfbNXiR̃fBAj
        int baseIdx1 = minIdx;
        int baseIdx2 = minIdx + (maxIdx - minIdx) / 2;
        int baseIdx3 = maxIdx;
        if (compare(runtime, array.getProperty(baseIdx1), array.getProperty(baseIdx2), compareFunction) > 0) {
            swap = array.getProperty(baseIdx1);
            array.putProperty(baseIdx1, array.getProperty(baseIdx2));
            array.putProperty(baseIdx2, swap);
        }
        if (compare(runtime, array.getProperty(baseIdx2), array.getProperty(baseIdx3), compareFunction) > 0) {
            swap = array.getProperty(baseIdx2);
            array.putProperty(baseIdx2, array.getProperty(baseIdx3));
            array.putProperty(baseIdx3, swap);
            if (compare(runtime, array.getProperty(baseIdx1), array.getProperty(baseIdx2), compareFunction) > 0) {
                swap = array.getProperty(baseIdx1);
                array.putProperty(baseIdx1, array.getProperty(baseIdx2));
                array.putProperty(baseIdx2, swap);
            }
        }
        if (maxIdx - minIdx == 2)
            return;        //  vfR̂Ƃ̎_Ŋɕł邱ƂɂȂ̂Ŗ߂
        int baseIdx = baseIdx2;
        int minSearch = minIdx + 1;
        int maxSearch = maxIdx - 1;
        
        
        IExpObject base = array.getProperty(baseIdx);    //  l
        while (minSearch <= maxSearch) {
            //  z̑Ol傫ȒlT
            while (compare(runtime, array.getProperty(minSearch), base, compareFunction) < 0) 
                minSearch = minSearch + 1;
            //  ž둤l菬ȒlT
            while (compare(runtime, array.getProperty(maxSearch), base, compareFunction) > 0) 
                maxSearch = maxSearch - 1;
            //  KvȂl
            if (minSearch <= maxSearch) {
                if (minSearch < maxSearch) {
                    //  ľ
                    swap = array.getProperty(minSearch);
                    array.putProperty(minSearch, array.getProperty(maxSearch));
                    array.putProperty(maxSearch, swap);
                }
                
                minSearch = minSearch + 1; 
                maxSearch = maxSearch - 1;
            }
        }
        if (minIdx < maxSearch)
            sort(runtime, array, minIdx, maxSearch, compareFunction);  // O\[g
        if (minSearch < maxIdx)
            sort(runtime, array, minSearch, maxIdx, compareFunction);  // 㔼\[g
    }
    
    /**
     * IuWFNgm̔rs܂B
     * @param runtime ^Cf[^
     * @param a rΏ1
     * @param b rΏ2
     * @param compareFunction rp̊֐(null̏ꍇftHg삪gp)
     * @return rʁi̒l:a, 0:ab͓, ̒l:a傫j
     * @throws ExpException
     */
    public int compare(RuntimeData runtime, IExpObject a, IExpObject b, IFunction compareFunction) throws ExpException {
        if (compareFunction != null) {
            IExpObject compareObject = compareFunction.callFunction(runtime, null, new IExpObject[] {a, b});
            if (compareObject instanceof ExpNumberBase) {
                double compareNum = ((ExpNumberBase)compareObject).doubleValue();
                if (compareNum < 0)
                    return -1;
                else if (compareNum > 0)
                    return 1;
                else
                    return 0;
            } else {
                throw new ExpException(Expresser.getResString("CompareFunctionResultNotNumber"), -1);
            }
        }
        
        if (a instanceof ExpNumberBase && b instanceof ExpNumberBase) {
            double numA = ((ExpNumberBase)a).doubleValue();
            double numB = ((ExpNumberBase)b).doubleValue();
            
            if (numA < numB)
                return -1;
            else if (numA > numB)
                return 1;
            else
                return 0;
        } else if (a instanceof ExpDate && b instanceof ExpDate) {
            Date dateA = ((ExpDate)a).getDate();
            Date dateB = ((ExpDate)b).getDate();
            
            return dateA.compareTo(dateB);
        } else {
            String strA = null;// = a.toString();
            String strB = null;// = b.toString();
            Object toString;
            //   a𕶎񉻂
            if (a instanceof IExpObject) {
                toString = ((IExpObject)a).getProperty(StringToId.toId("toString"));
                if (toString != Expresser.UNDEFINED && toString != null) {
                    strA = ((IFunction)toString).callFunction(runtime, a, new IExpObject[] {}).toString();
                }
            }
            if (strA == null)
                strA = a.toString();
            //   b𕶎񉻂
            if (b instanceof IExpObject) {
                toString = ((IExpObject)b).getProperty(StringToId.toId("toString"));
                if (toString != Expresser.UNDEFINED && toString != null) {
                    strB = ((IFunction)toString).callFunction(runtime, b, new IExpObject[] {}).toString();
                }
            }
            if (strB == null)
                strB = b.toString();
                
            //   r
            return strA.compareTo(strB);
        }
    }
}
