package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;

import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * Array^ toLocaleString() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/08
 * 
 * @author m.matsubara
 */

public class Array__toLocaleString extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("toLocaleString");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Array__toLocaleString() throws ExpException {
        super("toLocaleString", 2);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        IArray value = (IArray)thisObject;
        
        int length = value.length();
        if (length <= 0) {
            return new _String("");
        }
        
        ITypeConverter typeConverter = runtime.getTypeConverter();
        StringBuffer result = new StringBuffer();
        result.append(typeConverter.toString(runtime, toLocaleString(value.getProperty(0), runtime)));
        for (int idx = 1; idx < length; idx++) {
            result.append(",");
            result.append(typeConverter.toString(runtime, toLocaleString(value.getProperty(idx), runtime)));
        }
        return new _String(result.toString());
    }
    
    /**
     * IuWFNg̎ toLocaleString() ɂĒn扻ꂽ𓾂܂B
     * @param object Ώۂ̃IuWFNg
     * @param runtime ^Cf[^
     * @return n扻ꂽ
     * @throws ExpException
     */
    public IExpObject toLocaleString(IExpObject object, RuntimeData runtime) throws ExpException {
        if (object instanceof IExpObject) {
            IExpObject toLocaleStringObj = ((IExpObject)object).getProperty(ID);
            if (toLocaleStringObj instanceof IFunction) {
                return ((IFunction)toLocaleStringObj).callFunction(runtime, object, new IExpObject[] {});
            }
        }
        return object;  //  _String߂ȂǎdȂB
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Array__toLocaleString();
        return instance;
    }
}
