package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._Integer;

/**
 * Array^ unshift() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/10
 * 
 * @author m.matsubara
 */

public class Array__unshift extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("unshift");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Array__unshift() throws ExpException {
        super("unshift", 2);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        IArray array = (IArray)thisObject;
        int length = array.length();
        int argLength = arguments.length;
        length += argLength;
        array.setLength(length);
        
        for (int idx = length - 1; idx >= argLength; idx--) {
            IExpObject value = array.getProperty(idx - argLength);
            array.putProperty(idx, value);
        }
        for (int idx = 0; idx < argLength; idx++) {
            array.putProperty(idx, arguments[idx]);
        }
        return new _Integer(length);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Array__unshift();
        return instance;
    }
}
