package jp.gr.java_conf.matsubara.expresser.type.property;

import java.text.DateFormat;
import java.text.SimpleDateFormat;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpDate;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;


/**
 * Date^ toDateString() \bhłB<br/>
 * <br/>
 * 쐬: 2005/04/03
 * 
 * @author m.matsubara
 */

public class Date__toDateString extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("toDateString");
    private static IExpObject instance; 
    private static DateFormat formatter = null;
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Date__toDateString() throws ExpException {
        super("toDateString", 0);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        ExpDate date = (ExpDate)thisObject;
        if (date.isNaN())
            return new _String("Invalid Date");
        if (formatter == null)
            formatter = new SimpleDateFormat(ExpDate.DEFAULT_DATE_FORMAT, ExpDate.DEFAULT_FORMAT_LOCALE);
        _String result = new _String(formatter.format(date.getDate())); 
        return result;
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Date__toDateString();
        return instance;
    }
}
