package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;


/**
 * EcmaScript FunctionIuWFNgcall\bhłB<br/>
 * 
 * 쐬: 2005/03/05
 * 
 * @author m.matsubara
 */
public class Function__apply extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("apply");
    private static IExpObject instance = null;
    
    /**
     * FunctionIuWFNgcall\bh`܂B
     * 
     */
    private Function__apply() throws ExpException {
        super("apply", 2);
    }
    
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments) throws ExpException {
        if (arguments.length != 2)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);

        IFunction superFunction = (IFunction)thisObject;    //  pIuWFNg̊֐
        IExpObject callThisObject = (IExpObject)arguments[0];
        IExpObject[] callArguments = ((IArray)arguments[1]).toArray();
        
        return superFunction.callFunction(runtime, callThisObject, callArguments);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Function__apply();
        return instance;
    }
}
