package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type.JavaClass;

/**
 * Global^ loadClass() \bhłB<br/>
 * ̃\bhECMA262Kiɂ͂܂<br/>
 * <br/>
 * 쐬: 2005/07/24
 * 
 * @author m.matsubara
 */

public class Global__loadClass extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("loadClass");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__loadClass() throws ExpException {
        super("loadClass", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length != 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        try {
            return new JavaClass(Class.forName(arguments[0].toString()));
        } catch (ClassNotFoundException e) {
            throw new ExpException(Expresser.getResString("FailureLoadClass"), -1);
        }
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__loadClass();
        return instance;
    }
}
