package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._Double;

/**
 * Global^ parseFloat() \bhłB<br/>
 * ̃\bhECMA262Kiɂ͂܂<br/>
 * <br/>
 * 쐬: 2005/07/24
 * 
 * @author m.matsubara
 */

public class Global__parseFloat extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("parseFloat");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__parseFloat() throws ExpException {
        super("parseFloat", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        
        ITypeConverter typeConverter = runtime.getTypeConverter(); 
        //  𔻒
        int radix = -1;
        if (arguments.length >= 2) {
            radix = typeConverter.toNumber(runtime, arguments[1]).intValue();
            if (radix < 0 || radix > 36) {
                return new _Double(Double.NaN);
            }
        }
        String string = typeConverter.toString(runtime, arguments[0]).toString().trim();
        
        return new _Double(Double.parseDouble(string));
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__parseFloat();
        return instance;
    }
}
