package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpRegExp;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * String^ replace() \bhłB<br/>
 * <br/>
 * 쐬: 2005/04/03
 * 
 * @author m.matsubara
 */

public class String__replace extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("replace");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private String__replace() throws ExpException {
        super("replace", 2);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        String value = ((IExpObject)thisObject).toString();
        if (arguments.length < 2)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);

        //  TODO ExpRegExp  global vpeBǉ炻̏Lq邱
        if (arguments[0] instanceof ExpRegExp) {
            ExpRegExp regExp = null;
            regExp = (ExpRegExp)(arguments[0]);
            ITypeConverter typeConverter = runtime.getTypeConverter();
            String result = regExp.replace(value, typeConverter.toString(runtime, arguments[1]).toString());
            return new _String(result);
        } else if (arguments[0] instanceof _String) {
            String before = arguments[0].toString(); 
            String after = arguments[1].toString();
            int begin = value.indexOf(before);
            if (begin < 0)
                return new _String(value);
            return new _String(value.substring(0, begin) + after + value.substring(begin + before.length())); 
        } else {
            throw new ExpException(Expresser.getResString("ArgumentError"), -1);
        }
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new String__replace();
        return instance;
    }
}
