package jp.gr.java_conf.matsubara.expresser.type.property;

import java.util.ArrayList;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpArray;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;


/**
 * String^ split() \bhłB<br/>
 * <br/>
 * 쐬: 2005/04/03
 * 
 * @author m.matsubara
 */

public class String__split extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("split");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private String__split() throws ExpException {
        super("split", 2);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        String value = ((IExpObject)thisObject).toString();

        //  sep p[^̎o
        String sep = null;
        if (arguments.length >= 1) {
            sep = arguments[0].toString();
        }
        
        //  limit p[^̎o
        int limit = Integer.MAX_VALUE;
        if (arguments.length >= 2) {
            try {
                limit = ((ExpNumberBase)(arguments[0])).intValue();
            } catch (ClassCastException cce) {
                limit = runtime.getTypeConverter().toNumber(runtime, arguments[0]).intValue();
            }
        }
        
        //  Z
        if (sep != null) {
            IExpObject[] resultArray = split(value, sep.charAt(0), limit);
            ExpArray result = new ExpArray(resultArray);
            return result;
        } else {
            ExpArray result = new ExpArray(1);
            result.putProperty(0, thisObject);
            return result;
        }
    }
    
    
    /**
     * ̕܂
     * @param source 
     * @param ch ̃Zp[^
     * @param limit ő啪
     * @return ꂽ̔z(ExpString̔z)
     */
    protected IExpObject[] split(String source, char ch, int limit) throws ExpException {
        ArrayList resultList = new ArrayList();
        int begin = 0;
        int max = source.length();
        for (int idx = 0; idx < max; idx++) {
            if (source.charAt(idx) == ch && resultList.size() < limit - 1) {
                String str = source.substring(begin, idx);
                resultList.add(new _String(str));
                begin = idx + 1;
            }
        }
        if (begin != max) {
            String str = source.substring(begin, max);
            resultList.add(new _String(str));
        }
        return (IExpObject[])resultList.toArray(new IExpObject[resultList.size()]); // TODO ̂ővmF
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new String__split();
        return instance;
    }
}
