package jp.gr.java_conf.matsubara.interpreter.ecmascript.parser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.SynchronizedStatement;

/**
 * synchronized Xe[ggłB<br/>
 * <br/>
 * 쐬: 2005/05/17
 * 
 * @author m.matsubara
 *
 */
public class SynchronizedStatementParser implements IStatementParser {
    public String targetStatement() {
        return "synchronized";
    }
    
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#parseStatement(jp.gr.java_conf.matsubara.interpreter.ScriptEngine, jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement, java.lang.String, char[], int, int, java.lang.Integer)
     */
    public int parseStatement(ScriptEngine se, BlockStatement blockStatement, String statementWord, char[] script, int begin, int end, Integer labelID) throws ExpException {
        int idx = begin;
        int statementLength = statementWord.length();
        
        int objectBeginIdx = Expresser.skipWhitespace(script, idx + statementLength, end);
        if (script[objectBeginIdx] != '(')
            throw new ExpException(ScriptEngine.getResString("NecessaryParentheses"), objectBeginIdx);
        int objectEndIdx = Expresser.skipParenthesis(script, objectBeginIdx, end);
        IParsedExpression synchronizedExpression = se.getExpresser().parse(script, objectBeginIdx + 1, objectEndIdx - 1);

        idx = objectEndIdx;
        BlockStatement loopStatement = new BlockStatement();
        idx = Expresser.skipWhitespace(script, idx, end);
        idx = se.parseStatement1(loopStatement, script, idx, end);
        SynchronizedStatement statement = new SynchronizedStatement(synchronizedExpression, loopStatement.getStatement(0));
        blockStatement.add(statement);
        
        return idx;
    }
}
