package jp.gr.java_conf.matsubara.interpreter.ecmascript.parser;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;
import jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.IStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.VariableDefineStatement;

/**
 * var Xe[ggłB<br/> 
 * 
 * 쐬: 2005/03/07
 * 
 * @author m.matsubara
 */
public class VarStatementParser implements IStatementParser {
    public String targetStatement() {
        return "var";
    }
    
    /* (Javadoc Ȃ)
     * @see jp.gr.java_conf.matsubara.interpreter.ecmascript.parser.IStatementParser#parseStatement(jp.gr.java_conf.matsubara.interpreter.ScriptEngine, jp.gr.java_conf.matsubara.interpreter.statement.BlockStatement, java.lang.String, char[], int, int, java.lang.Integer)
     */
    public int parseStatement(ScriptEngine se, BlockStatement blockStatement, String statementWord, char[] script, int begin, int end, Integer labelID) throws ExpException {
        int idx = begin;
        int nStatementLength = statementWord.length();
        Integer id;
        IParsedExpression initialExpression = null;
        idx = Expresser.skipWhitespace(script, idx + nStatementLength, end);
        
        while (idx < end) {
            //  ʎqiϐj̎擾
            int beginIdx = idx;
            int endIdx;
            String identifier = se.getExpresser().nextToken(script, beginIdx, end);
            idx = idx + identifier.length(); 
            id = StringToId.toId(identifier);
            idx = Expresser.skipWhitespace(script, idx, end);
    
            //  
            if (idx + 1 < end && script[idx] == '=') {
                idx = Expresser.skipWhitespace(script, idx + 1, end);
                beginIdx = idx;
                idx = skipExpression(script, beginIdx, end);
                endIdx = idx - 1;
                initialExpression = se.getExpresser().parse(script, beginIdx, endIdx);
                idx--;
            }
            IStatement statement = new VariableDefineStatement(id, initialExpression);
            blockStatement.add(statement);
            if (script[idx] != ',')
                break;
            idx++;
            idx = Expresser.skipWhitespace(script, idx, end);
        }
        if (idx < end) {
            if (script[idx] != ';')
                throw new ExpException(ScriptEngine.getResString("NecessarySemicolon"), idx);
            else
                idx++;
        }
        
        return idx;
    }
    
    /**
     * ̎̏I܂œǂݔ΂܂B<br/>
     * J}ł̏IƔf邱ƂɒӂȂ΂Ȃ܂B
     * @param script XNvg
     * @param begin Jnʒu
     * @param end Iʒu
     * @return Z~R܂̓J}̈ʒu+1
     * @throws ExpException
     */
    public static int skipExpression(char[] script, int begin, int end) throws ExpException {
        int idx = begin;
        while (idx < end) {
            char ch = script[idx];
            if (ch == '{' || ch == '(' || ch == '[')
                idx = Expresser.skipParenthesis(script, idx, end);
            else if (ch == '\"' || ch == '\'')
                idx = Expresser.skipString(script, idx, end);
            else if (ch == ';' || ch == ',')
                return idx + 1;
            else {
                idx++;
            }
        }
        return end;
    }
}
