package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;


/**
 * for Xe[ggłB<br/>
 * 
 * 쐬: 2005/01/30
 * 
 * @author m.matsubara
 */
public class ForStatement implements IStatement {
    /** [v̏ */
    private IParsedExpression initialExpression; 
    /** JԂ */
    private IParsedExpression condition;
    /** [v̏IɎs鎮 */
    private IParsedExpression loopEndExpression;
    /** [v{ */
    private IStatement statement = null;
    /** JԂ̈ʒu */
    private int conditionIdx;   //  ݎgpĂȂgHiG[ʒǔoj
    /** xID */
    private Integer labelID;
    
    
    /**
     * for Xe[gg̐܂B
     * @param initialExpression vZ
     * @param condition JԂ
     * @param loopEndExpression [vGh̎
     * @param statement [v{
     * @param conditionIdx JԂʒu
     */
    public ForStatement(IParsedExpression initialExpression, IParsedExpression condition, IParsedExpression loopEndExpression, IStatement statement, int conditionIdx, Integer labelID) {
        this.initialExpression = initialExpression;
        this.condition = condition;
        this.loopEndExpression = loopEndExpression;
        this.statement = statement;
        this.conditionIdx = conditionIdx;
        this.labelID = labelID;
    }
    
    /**
     * Ԃ܂B
     * 
     * @return ͍ς݂̏
     */
    public IParsedExpression getCondition() {
        return condition;
    }
    
    /**
     * ]܂B
     * @param runtime ^Cf[^
     * @return ̕]
     * @throws ExpException
     */
    public boolean condition(RuntimeData runtime) throws ExpException {
        if (condition == null)
            return true;    //  w肳ĂȂꍇ͂̂܂܃[vs邽trueƂĂ܂
        IExpObject result = Expresser.evaluate(runtime, condition);
        if (result instanceof _Boolean) {
            return ((_Boolean)result).booleanValue();
        } else {
            return runtime.getTypeConverter().toBoolean(runtime, result).booleanValue();
        }
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int result = 0;
        if (initialExpression != null)
            result += initialExpression.isUsingVariable(id); 
        if (condition != null)
            result += condition.isUsingVariable(id);
        if (loopEndExpression != null)
            result += loopEndExpression.isUsingVariable(id);
        if (statement != null)
            result += statement.isUsingVariable(id);
        return result;
    }

    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData runtime)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        if (initialExpression != null)
            Expresser.evaluate(runtime, initialExpression);

        while (condition(runtime)) {
            if (statement != null) {
                StatementResult receive = statement.execute(runtime);
                if (receive != null) {
                    int statementType = receive.getStatementType();
                    if (statementType == StatementResult.ST_BREAK) {
                        if (receive.getLabelId() == null || this.labelID == receive.getLabelId())   //  x̓CX^Ẍv
                            return null;
                        else
                            return receive;
                    } else if (statementType == StatementResult.ST_CONTINUE) {
                        if (receive.getLabelId() == null || this.labelID == receive.getLabelId())   //  x̓CX^Ẍv
                            ;
                        else
                            return receive;
                    } else
                        return receive;
                }
            }
            //  ̃[v̏
            if (loopEndExpression != null)
                Expresser.evaluate(runtime, loopEndExpression);
        }
        return null;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.Map)
     */
    public void registLocalVariable(Map varMap) {
        if (statement != null)
            statement.registLocalVariable(varMap);
    }

    public int getConditionIdx() {
        return conditionIdx;
    }

    public void setConditionIdx(int conditionIdx) {
        this.conditionIdx = conditionIdx;
    }
}
