package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.type.ExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Double;
import jp.gr.java_conf.matsubara.expresser.type._String;


/**
 * vZ̕]Xe[ggłB<br/>
 * 
 * 쐬: 2005/01/16
 * 
 * @author m.matsubara
 */
public class Statement implements IStatement {
    private int position;
    private IParsedExpression parsedExpression;
    
    /**
     * vZXe[ggłB
     * @param parsedExpression ͍ς݃Xe[gg
     * @param position vZ̈ʒu
     * @throws ExpException
     */
    public Statement(IParsedExpression parsedExpression, int position) {
        this.parsedExpression = parsedExpression;
        this.position = position;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        if (parsedExpression != null)
            return parsedExpression.isUsingVariable(id);
        return 0;
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        try {
            //  Z
            IExpObject result = parsedExpression.evaluate(runtime);
            //  Zʂϐ̏ꍇA̒l擾
            if (result instanceof IVariable)
                result = ((IVariable)result).getValue();
            //  ŏIZʂXV
            runtime.setLastResultValue(result);
        } catch (StatementResultNotification srn) {
            return srn.getStatementResult();
        } catch (ExpException ee) {
            if (ee.getPosition() < 0)
                ee.setPosition(position);
            ExpObject error = new ExpObject("Error", null);
            error.putProperty(StringToId.toId("message"), new _String(ee.getMessage()));
            error.putProperty(StringToId.toId("position"), new _Double(ee.getPosition()));
            StatementResult statementResult = new StatementResult(StatementResult.ST_EXCEPTION, error, null);    //  Error^𑗏o悤ɂȂ΂ȂȂ
            return statementResult;
//          throw ee;
        }
        return null;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.Map)
     */
    public void registLocalVariable(Map varMap) {
        //  Ȃ
    }
    
}
