package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.Range;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;


/**
 * while Xe[ggłB<br/>
 * 
 * 쐬: 2005/01/16
 * 
 * @author m.matsubara
 *
 */
public class WhileStatement implements IStatement {
    /** while ̏ */
    private Range conditionRange;	//	gȂǏgH
    private IParsedExpression condition;
    private IStatement statement = null;
    private boolean doWhile;
    /** xID */
    private Integer labelID;
    
    
    public WhileStatement(IParsedExpression condition, Range conditionRange, IStatement statement, Integer labelID) {
        this.condition = condition;
        this.conditionRange = conditionRange;
        this.statement = statement;
        this.labelID = labelID;
        this.doWhile = false;
    }

    /**
     * do-whilei㔻̎jtrueɐݒ肵܂B
     * @param doWhile do-whilei㔻̎jtrueɐݒ肵܂B
     */
    public void setDoWhile(boolean doWhile) {
        this.doWhile = doWhile;
    }
    
    /**
     * do-whilei㔻̎jtrueԂ܂B
     * @return do-whilei㔻̎jtrueԂ܂B
     */
    public boolean isDoWhile() {
        return doWhile;
    }
    
    /**
     * ]܂B
     * @param runtime ^Cf[^
     * @return ̕]
     * @throws ExpException sG[
     */
    public boolean condition(RuntimeData runtime) throws ExpException {
        IExpObject result = Expresser.evaluate(runtime, condition);
        if (result instanceof _Boolean) {
            return ((_Boolean)result).booleanValue();
        } else {
            return runtime.getTypeConverter().toBoolean(runtime, result).booleanValue();
        }
    }
    

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int result = 0;
        if (condition != null)
            result += condition.isUsingVariable(id);
        if (statement != null)
            result += statement.isUsingVariable(id);
        return result;
    }

    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        if (statement != null) {
            if (doWhile) {
                //  DoWhile̎
                StatementResult receive = statement.execute(runtime);
                if (receive != null) {
                    int statementType = receive.getStatementType();
                    if (statementType == StatementResult.ST_BREAK) {
                        if (receive.getLabelId() == null || this.labelID == receive.getLabelId())   //  x̓CX^Ẍv
                            return null;
                        else
                            return receive;
                    } else if (statementType == StatementResult.ST_CONTINUE) {
                        if (receive.getLabelId() == null || this.labelID == receive.getLabelId())   //  x̓CX^Ẍv
                            ;
                        else
                            return receive;
                    } else
                        return receive;
                }
            }
            //  [v̎s
            while (condition(runtime)) {
                StatementResult receive = statement.execute(runtime);
                if (receive != null) {
                    int statementType = receive.getStatementType();
                    if (statementType == StatementResult.ST_BREAK) {
                        if (receive.getLabelId() == null || this.labelID == receive.getLabelId())   //  x̓CX^Ẍv
                            return null;
                        else
                            return receive;
                    } else if (statementType == StatementResult.ST_CONTINUE) {
                        if (receive.getLabelId() == null || this.labelID == receive.getLabelId())   //  x̓CX^Ẍv
                            ;
                        else
                            return receive;
                    } else
                        return receive;
                }
            }
        } else {
            //  [v{̂Ȃꍇ
            while (condition(runtime))
                ;
        }
        return null;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.Map)
     */
    public void registLocalVariable(Map varMap) {
        statement.registLocalVariable(varMap);
    }

    public Range getConditionRange() {
        return conditionRange;
    }

    public void setConditionRange(Range conditionRange) {
        this.conditionRange = conditionRange;
    }
}
