package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.interpreter.ScriptEngine;


/**
 * with Xe[ggłB<br/>
 * 
 * 쐬: 2005/01/16
 * 
 * @author m.matsubara
 */
public class WithStatement implements IStatement {
    private IParsedExpression withExpression;
    private IStatement withStatement = null;
    private int position;
    
    public WithStatement(IParsedExpression withExpression, IStatement withStatement, int position) {
        this.withExpression = withExpression;
        this.withStatement = withStatement;
        this.position = position;
    }
    
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer id)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int result = 0;
        if (withStatement != null)
            result += withStatement.isUsingVariable(id);
        return result;
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        Object withObject = Expresser.evaluate(runtime, withExpression);
        
        if ((withObject instanceof IExpObject) == false)
            throw new ExpException(ScriptEngine.getResString("IllegalWithObject"), position);
        runtime.addWithObject((IExpObject)withObject);
        try {
            StatementResult receive = withStatement.execute(runtime);
            if (receive != null)
                return receive;
        } finally {
            runtime.removeWithObject();
        }
        return null;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.Map)
     */
    public void registLocalVariable(Map varMap) {
        withStatement.registLocalVariable(varMap);
    }
}
